<?php
function bisiesto($year)
{
    if (($year % 4 == 0) && (($year % 100 != 0) || ($year % 400 == 0))) {
        return (1);
    } else {
        return (0);
    }
}


function validarFecha($dia, $mes, $year = 15)
{
    $fechaValida = 0;
    $diasMes = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    $diasMes[2] += bisiesto($year);
    if ($mes >= 1 && $mes <= 12 && $dia >= 1 && $dia <= $diasMes[$mes] && $year >= 1) {
        $fechaValida = 1;
    }
    return ($fechaValida);
}


function cantidadDias($dia, $mes, $year)
{
    $total = 0;
    $diasMes = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    $diasMes[2] += bisiesto($year);
    if (validarFecha($dia, $mes, $year) == 1) {
        $year--;
        $total = ($year) * 365;
        $total += ($year - ($year % 4)) / 4;
        $total -= ($year - ($year % 100)) / 100;
        $total += ($year - ($year % 400)) / 400;
        for ($m = 0; $m < $mes; $m++) {
            $total += $diasMes[$m];
        }
        $total += $dia;
        return $total;
    } else {
        return -1;
    }
}


function diaSemana($dia, $mes, $year){
    if(validarFecha($dia, $mes, $year) == 1){
        $total = cantidadDias($dia, $mes, $year);
        $total = $total % 7;
        if($total == 0){
            $total = 7;
        }
        return $total;
    } else {
        return -1;
    }
}


function diaSemanaTexto($dia, $mes, $year){
    $dia = diaSemana($dia, $mes, $year);
    if($dia >= 1){
        $dias = ["", "LUNES", "MARTES", "MIÉRCOLES", "JUEVES", "VIERNES", "SÁBADO", "DOMINGO"];
        return $dias[$dia];
    } else {
        return -1;
    }
}


function pintarMes($mes, $year){

    $meses = ["enero", "febrero", "marzo", "abril", "mayo", "junio", "julio", "agosto", "septiembre", "octubre", "noviembre", "diciembre"];
    $diasdelasemana = ["lunes", "martes", "miércoles", "jueves", "viernes", "sábado", "domingo"];
    $diasMeses = [0, 31, 28 + bisiesto($year), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

    echo "<table><caption>" . $meses[$mes-1].  " de " . $year . "</caption><thead><tr>";
    foreach ($diasdelasemana as $key => $value) {
        echo "<th>" . $value . "</th>";
    }
    echo "</tr><thead><tbody>";
    $dia = 1;
    $contador = 1;
    
    while($dia < $diasMeses[$mes]){
        echo "<tr>";
            for ($d=1; $d <= 7; $d++) { 
                echo "<td>";
                if($contador >= diaSemana(1, $mes, $year) && $dia <= $diasMeses[$mes]){
                    echo $dia++;
                }
                $contador++;
                echo "</td>";
            }
        echo "</tr>";
    }

    echo "</tbody></table>";
}


function pintarYear($year, $mes = 1){
    pintarMes($mes, $year);
    if($mes < 12){
        pintarYear($year, $mes + 1);
    }
    echo "<p>TERMINAR EL MES " . $mes . "</p>";
}